package dev.shadowsoffire.apotheosis.ench.objects;

import java.util.Collections;
import net.minecraftforge.event.entity.player.AnvilRepairEvent;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Map;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraftforge.event.AnvilUpdateEvent;
import net.minecraft.world.item.Rarity;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import java.util.Random;
import net.minecraft.world.item.BookItem;

public class ExtractionTomeItem extends BookItem
{
    static Random rand;
    
    public ExtractionTomeItem() {
        super(new Item.Properties());
    }
    
    public boolean m_8120_(final ItemStack stack) {
        return false;
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level world, final List<Component> tooltip, final TooltipFlag flagIn) {
        if (stack.m_41793_()) {
            return;
        }
        tooltip.add((Component)Component.m_237115_("info.apotheosis.extraction_tome").m_130940_(ChatFormatting.GRAY));
        tooltip.add((Component)Component.m_237115_("info.apotheosis.extraction_tome2").m_130940_(ChatFormatting.GRAY));
    }
    
    public Rarity m_41460_(final ItemStack stack) {
        return Rarity.EPIC;
    }
    
    public boolean m_5812_(final ItemStack pStack) {
        return true;
    }
    
    public static boolean updateAnvil(final AnvilUpdateEvent ev) {
        final ItemStack weapon = ev.getLeft();
        final ItemStack book = ev.getRight();
        if (!(book.m_41720_() instanceof ExtractionTomeItem) || book.m_41793_() || !weapon.m_41793_()) {
            return false;
        }
        final Map<Enchantment, Integer> wepEnch = EnchantmentHelper.m_44831_(weapon);
        final ItemStack out = new ItemStack((ItemLike)Items.f_42690_);
        EnchantmentHelper.m_44865_((Map)wepEnch, out);
        ev.setMaterialCost(1);
        ev.setCost(wepEnch.size() * 16);
        ev.setOutput(out);
        return true;
    }
    
    protected static void giveItem(final Player player, final ItemStack stack) {
        if (!player.m_6084_() || (player instanceof ServerPlayer && ((ServerPlayer)player).m_9232_())) {
            player.m_36176_(stack, false);
        }
        else {
            final Inventory inventory = player.m_150109_();
            if (inventory.f_35978_ instanceof ServerPlayer) {
                inventory.m_150079_(stack);
            }
        }
    }
    
    public static boolean updateRepair(final AnvilRepairEvent ev) {
        final ItemStack weapon = ev.getLeft();
        final ItemStack book = ev.getRight();
        if (!(book.m_41720_() instanceof ExtractionTomeItem) || book.m_41793_() || !weapon.m_41793_()) {
            return false;
        }
        EnchantmentHelper.m_44865_((Map)Collections.emptyMap(), weapon);
        giveItem(ev.getEntity(), weapon);
        return true;
    }
    
    static {
        ExtractionTomeItem.rand = new Random();
    }
}
